package org.aspectjml.lang.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@Documented
public @interface After {

    /**
     * The pointcut expression where to bind the advice
     */
	String value() default "";
    
    /**
     * The pointcut expression where to bind the advice, overrides "value" when specified
     */
    String pointcut() default "";
    
    /**
     * 
     * This indicates whether or not to intercept other potential advice methods  
     */
    boolean adviceinterception() default true;
    
    /**
     * 
     * This indicates whether or not to allow reentrant interception by pointcut-advice
     */
    boolean reentering() default false;
    
    /**
     * 
     * This indicates whether or not to allow reentrant interception triggered by the advice body
     */
    boolean selfreentering() default false;
    
    /**
     * 
     * This indicates whether or not to allow interception at valid subtypes
     */
    boolean subtyping() default true;
    
//    String argNames() default "";
}
